
;*****************************************************
;+++EEPROM-Routinen fr 16F628************************
;*****************************************************
; 16F628 hat 128 EEPROM-Zellen

;	EEADR 		Bank 1
;	EEDATA		Bank 1
;	EECON1		Bank 1
;	EECON2 		Bank 1

;*****************************************************


;*****************************************************
; speichern des Mode ->[0]
SaveMode
	movfw	Mode
	movwf	EEWriteData
	movlw	0
	call	EEWrite	
	return

; laden des Mode (0..2),  [0] -> Mode
LoadMode
	movlw	0
	call	EERead
	movwf	Mode
	sublw	2	; 2-w 	C=ok
	skpc
	clrf	Mode
	return



;*****************************************************
;*****************************************************
; lesen der Zelle ^W nach W
; lesen der Zelle deren Adresse in W stehtW nach W
EERead
	BSF  	STATUS, RP0 	; EEADR liegt in der Bank 1 
 	MOVWF 	EEADR 		; schreibe die Adresse in EEADR 
	BSF  	EECON1, RD 	; EEPROM Leseproze starten 
	MOVF 	EEDATA, W 	; Die Daten der EEPROM Zelle nach W kopieren 
	BCF 	STATUS, RP0 	; Bank 0 
	return


;*****************************************************
; schreibe EEWriteData in Zelle ^W
EEWrite
	BSF 	STATUS, RP0 	; EEADR liegt in der Bank 1
	MOVWF 	EEADR 		; Die Zelle @W soll beschrieben werden 
	BCF 	STATUS, RP0	; EEWritedata liegt in Bank 0
	MOVFW 	EEWriteData	
	BSF 	STATUS, RP0 	; EEDATA liegt in der Bank 1
	MOVWF 	EEDATA 		; EEWriteData wollen wir schreiben 
	BSF 	EECON1, WREN 	; nun ist Schreiben erlaubt 
	;BCF	INTCON, GIE	; Disable INTs.

; Die folgenden 5 Zeilen mssen genau so im Code stehen!!! 
	MOVLW 	055h
	MOVWF 	EECON2 		; schreibe 55h nach EECON2 
	MOVLW 	0AAh
	MOVWF 	EECON2 		; schreibe AAh nach EECON2 
	BSF 	EECON1, WR 	; starte den Schreibzyklus 
EEWrite1			; warten das write fertig ist
	btfsc	EECON1, WR
	goto	EEWrite1
	BCF	EECON1, WREN	; disable schreiben
	BCF 	STATUS, RP0 	; Bank 0 
	;BSF	INTCON, GIE	; Enable INTs.
	return

;*****************************************************

